<script lang="ts">
  import type { PlayerId, State, Player, Settings } from "../server";
  import Action from "./Action.svelte";
  import CardBack from "./CardBack.svelte";
  import CardFront from "./CardFront.svelte";
  import Deck from "./Deck.svelte";
  import EndSummary from "./EndSummary.svelte";
  import OtherPlayer from "./OtherPlayer.svelte";

  import PlayerComponent from "./Player.svelte";
  import RoundComplete from "./RoundComplete.svelte";
  import orderPlayers, { indexed, reversed } from "./util/utils";

  export let playerId: PlayerId | undefined;
  export let state: State;
  export let settings: Settings;

  $: orderedPlayers = orderPlayers(state.players, playerId);

  function getPlayerStyle(
    player: Player,
    userId: PlayerId | undefined,
    playerCount: number,
    idx: number
  ) {
    const radius = 23;

    const startAngle = Math.PI / 2;
    const angleStep = (2 * Math.PI) / playerCount;

    const angle = startAngle + angleStep * idx;

    const translateX = Math.cos(angle) * radius;
    const translateY = 0.9 * Math.sin(angle) * radius;

    return `
      --translate-x: ${translateX.toFixed(2)}em;
      --translate-y: ${translateY.toFixed(2)}em;
    `;
  }

  let player: Player | null;
  $: {
    player = state.players.find((p) => p.id === playerId) ?? null;
  }
</script>

<div class="wrapper">
  <div class="game-components">
    <div class="cards">
      <div class="card">
        <Deck deck={state.deck} />
      </div>
    </div>

    {#if state.face_up}
      <div class="face-up">
        <div class="card">
          <CardBack />
        </div>
        {#each state.face_up as card (card)}
          <div class="card">
            <CardFront {card} />
          </div>
        {/each}
      </div>
    {:else}
      <div class="card">
        <CardBack />
      </div>
    {/if}
  </div>

  <div class="players">
    {#each state.players as player (player.id)}
      <div
        class:user={player.id === playerId}
        style={getPlayerStyle(
          player,
          playerId,
          state.players.length,
          orderedPlayers.findIndex((p) => p.id === player.id)
        )}
      >
        {#if player.id === playerId}
          <div class="player">
            <PlayerComponent on:action {player} {state} />
          </div>
        {:else}
          <div class="player">
            <OtherPlayer
              playerState={player}
              phase={state.phase}
              speech={state.speech[player.id]}
            />
          </div>
        {/if}
      </div>
    {/each}
  </div>

  {#if player !== null}
    <div class="action">
      <Action on:action playerId={player.id} {state} {settings} />
    </div>
  {/if}

  {#if state.phase.kind === "GameComplete"}
    <div class="summary panel">
      <EndSummary players={state.players} />
    </div>
  {/if}

  {#if state.phase.kind === "RoundComplete"}
    <div class="summary panel">
      <RoundComplete on:action {state} {playerId} />
    </div>
  {/if}
</div>

<style>
  .wrapper {
    position: relative;
    height: 100%;
    width: 100%;
    min-width: 50em;
  }
  .game-components {
    position: absolute;
    left: 50%;
    top: 50%;
    transform: translate(-50%, -50%) translateY(-2rem);

    font-size: 0.5em;
    display: flex;
    flex-wrap: nowrap;
    justify-content: center;
    align-items: center;
  }
  .players {
    position: absolute;
    left: 50%;
    top: 50%;
    transform: translate(-50%, -50%);
  }

  .player {
    position: absolute;
    transform: translate(-50%, -50%) translateX(var(--translate-x))
      translateY(var(--translate-y));
    transition: transform 0.5s;
  }
  .cards {
    display: flex;
  }
  .card {
    margin: 0.5rem;
  }

  .face-up {
    display: flex;
    width: 18em;
  }
  .face-up > .card {
    margin-left: 0em;
    margin-right: -7.5em;
  }

  .summary {
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);
  }
  .action {
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%) translateY(1.5rem);
  }
</style>
